<?php

namespace Flat101\ProductCompare\Plugin;

use Flat101\ProductCompare\Helper\Data as ModuleHelper;

class AbstractProduct
{
    /**
     * @var ModuleHelper
     */
    private $moduleHelper;

    public function __construct(ModuleHelper $moduleHelper)
    {
        $this->moduleHelper = $moduleHelper;
    }

    /**
     * Return 'null' for product compare url if product comparison is disabled. This deals with a number
     * of the templates that rely on this being set to actually show the compare links.
     *
     * @param \Magento\Catalog\Block\Product\AbstractProduct $subject
     * @param string $result
     * @return string|null
     */
    public function afterGetAddToCompareUrl(
        \Magento\Catalog\Block\Product\AbstractProduct $subject,
        $result
    ) {
        $disableCompare = $this->moduleHelper->isEnabled();

        if ($disableCompare) {
            $result = null;
        }

        return $result;
    }
}
